package ink.wgink.module.map.service.grid;

import ink.wgink.module.map.pojo.dtos.grid.GridGroupDTO;
import ink.wgink.module.map.pojo.pos.grid.GridGroupPO;
import ink.wgink.module.map.pojo.vos.grid.GridGroupVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IGridGroupService
 * @Description: 网格组
 * @Author: wanggeng
 * @Date: 2021/10/19 10:25 下午
 * @Version: 1.0
 */
public interface IGridGroupService {

    /**
     * 新增网格组
     *
     * @param gridGroupVO
     * @throws Exception
     */
    void save(GridGroupVO gridGroupVO) throws Exception;

    /**
     * 新增网格组
     *
     * @param gridGroupVO
     * @return 网格组ID
     * @throws Exception
     */
    String saveAndReturnId(GridGroupVO gridGroupVO) throws Exception;

    /**
     * 删除网格组
     *
     * @param asList
     */
    void remove(List<String> ids);

    /**
     * 修改网格组
     *
     * @param gridGroupId
     * @param gridGroupVO
     * @throws Exception
     */
    void update(String gridGroupId, GridGroupVO gridGroupVO) throws Exception;

    /**
     * 网格组详情
     *
     * @param params
     * @return
     */
    GridGroupDTO get(Map<String, Object> params);

    /**
     * 网格组详情
     *
     * @param gridGroupId 网格组ID
     * @return
     */
    GridGroupDTO get(String gridGroupId);

    /**
     * 网格组详情
     *
     * @param gridGroupCode
     * @return
     */
    GridGroupDTO getByCode(String gridGroupCode);

    /**
     * 网格组详情
     *
     * @param params
     * @return
     */
    GridGroupPO getPO(Map<String, Object> params);

    /**
     * 网格组详情
     *
     * @param gridGroupId
     * @return
     */
    GridGroupPO getPO(String gridGroupId);

    /**
     * 网格组详情
     *
     * @param gridGroupCode
     * @return
     */
    GridGroupPO getPOByCode(String gridGroupCode);

    /**
     * 网格组列表
     *
     * @param params
     * @return
     */
    List<GridGroupDTO> list(Map<String, Object> params);

    /**
     * 网格组分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<GridGroupDTO>> listPage(ListPage page);
}
